unit Unit2;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, ComCtrls, Buttons, LCLType, lazutf8;

type
  qq = record
    question: string[255];
    otvet: integer;
  end;

type
  player_otbor = record
    Name: string[255];
    answer, blizost: integer;
    time: real;
    sgor, nesgor, share: integer;
  end;
  {   type    tq = record
    question: string;
    otvet: string;
    end;  }
type
  question_one_two = record
    question: string;
    variant: array[1..4] of string;
    picked: array [1..4] of boolean;
    correct: byte;
  end;

type
  question_three_four = record
    question: string;
    variant: array[1..5] of string;
    picked: array [1..5] of boolean;
    correct: byte;
  end;

type
  question_five_six_seven_eight = record
    question: string;
    variant: array [1..9] of string;
    correct: array [1..4] of byte;
    freebie: byte;
  end;

type
  TButton = class(StdCtrls.TButton)
    procedure click; override;
  end;

type
  TPanel = class(extCtrls.Tpanel)
    procedure click; override;
  end;

type
  term = record
    tekst, otvet: string;
    has_been: boolean;
  end;

type
  TStage = (otvet, kap, zamen, proverka, raund, default);
  _Term = (rnd, otvet_term, pressed_term, after, no);

  { TForm2 }

  TForm2 = class(TForm)
    accept_1234: TButton;
    terminator_answer: TEdit;
    term_text: TLabel;
    reject_1234: TButton;
    Edit1: TEdit;
    Button1: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    qotb: TLabel;
    check: TTimer;
    term: TTimer;
    dobav: TTimer;
    check2: TTimer;
    _5to1: TTimer;
    vopros: TTimer;
    tim_otbor: TTimer;

    procedure accept_1234Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure check2Timer(Sender: TObject);
    procedure checkStartTimer(Sender: TObject);
    procedure checkTimer(Sender: TObject);
    procedure dobavTimer(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit1Enter(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: char);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure reject_1234Click(Sender: TObject);
    procedure terminator_answerKeyPress(Sender: TObject; var Key: char);
    procedure termTimer(Sender: TObject);
    procedure tim_otborTimer(Sender: TObject);
    procedure voprosTimer(Sender: TObject);
    procedure _5to1Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

const
  dough: array [0..8] of integer =
    (0, 25000, 50000, 75000, 100000, 250000, 500000, 1000000, 2000000);
  varnumb: array [1..8] of byte = (4, 4, 5, 5, 6, 7, 8, 9);
  term_pinigai = 25000;
  bailout: array [5..7] of integer = (25000, 50000, 100000);

var
  Form2: TForm2;
  baseq, baset, base1, base2, base3, base4, base5, base6, base7, base8: textfile;
  counter, rr, rr2, pv, z: integer;
  q0: array [1..80] of qq;
  player_osn: array [1..5] of tlabel;
  money: array [1..5] of tedit;
  q1: array [1..80] of question_one_two;
  q2: array [1..80] of question_one_two;
  q3: array [1..80] of question_three_four;
  q4: array [1..80] of question_three_four;
  q5, q6, q7, q8: array [1..80] of question_five_six_seven_eight;
  respuestas: array [1..9] of tpanel;
  termstage: _term;
  players, dummy: byte;
  _14stage: tstage;
  _14picked: byte;
  t3rminator: array [1..80] of term;
  termplayer: array [1..2] of byte;
  challenge: array [1..5] of TButton;
  buzzer: array [1..2] of tpanel;
  termwas: boolean;
  term_vernoli: boolean;
  winrar, loser: byte;
  kolvo: array [1..8] of byte;
  dummy_string: string;
  _567: (priem, zamena1, zamena2, _proverka, joker);
  number_of_corr, randprov: byte;
  aceptadas, revealed: array [1..9] of boolean;
  nom_otv, activ, kolvo_otv: byte;
  golosoval: array [1..5] of boolean;
  freebie_avail, freebied, krug, yummy: boolean;
  va_a_contestar: array [1..5] of TButton;
//activ: byte;
implementation

uses unit1;

{$R *.lfm}
{ TForm2 }
procedure viele_richtig;
begin
  form2.check2.Enabled := True;
  form2.check2.tag := 0;
  begin
    number_of_corr := 0;
    for a := 1 to varnumb[form2.vopros.tag] do
      for b := 1 to 4 do
      begin
        case form2.vopros.tag of
          5: if (aceptadas[a] = True) and (q5[rr2].correct[b] = a) then
           begin   Inc(number_of_corr); //writeln(a);
           end;
          6: if (aceptadas[a] = True) and (q6[rr2].correct[b] = a) then
              Inc(number_of_corr);
          7: if (aceptadas[a] = True) and (q7[rr2].correct[b] = a) then
              Inc(number_of_corr);
          8: if (aceptadas[a] = True) and (q8[rr2].correct[b] = a) then
              Inc(number_of_corr);
        end;
      end;
    //writeln(number_of_corr);
  end;

end;

procedure combien_de_joueurs;
begin
  players := 0;
  for dummy := 1 to 5 do
  begin
    if (form1.qualsort[dummy].share > 0) then
      Inc(players);
  end;
end;

procedure bribe(f: byte);
begin
  combien_de_joueurs;
  for dummy := 1 to 5 do
  begin
    if (form1.qualsort[dummy].share > 0) then
      form1.qualsort[dummy].sgor := bailout[f] div players;
    money[dummy].Caption :=
      IntToStr(form1.qualsort[dummy].sgor + form1.qualsort[dummy].nesgor);
  end;
end;

procedure current_winnings(f: byte);
begin
  for dummy := 1 to 5 do
  begin
    if (form1.qualsort[dummy].share > 0) then
    begin
      form1.qualsort[dummy].sgor := dough[f] div
        (form1.qualsort[1].share + form1.qualsort[2].share + form1.qualsort[3].share +
        form1.qualsort[4].share + form1.qualsort[5].share) * form1.qualsort[dummy].share;
      money[dummy].Caption :=
        IntToStr(form1.qualsort[dummy].sgor + form1.qualsort[dummy].nesgor);
    end;
  end;
end;

procedure readq_1234(nomer: byte);
begin
  counter := 0;
  case nomer of
    1:
    begin
      assignfile(base1, 'qbase1.txt');
      reset(base1);
      while not EOF(base1) do
      begin
        readln(base1);
        Inc(counter);
      end;
      counter := counter div (2 + varnumb[nomer]);
      reset(base1);
      for rr := 1 to counter do
      begin
        readln(base1, q1[rr].question);
        for a := 1 to varnumb[nomer] do
          readln(base1, q1[rr].variant[a]);
        readln(base1, q1[rr].correct);
      end;
      closefile(base1);

    end;
    2:
    begin
      assignfile(base2, 'qbase2.txt');
      reset(base2);
      while not EOF(base2) do
      begin
        readln(base2);
        Inc(counter);
      end;
      counter := counter div (2 + varnumb[nomer]);
      reset(base2);
      for rr := 1 to counter do
      begin
        readln(base2, q2[rr].question);
        for a := 1 to varnumb[nomer] do
          readln(base2, q2[rr].variant[a]);
        readln(base2, q2[rr].correct);
      end;
      closefile(base2);
    end;
  end;
  //writeln('Вопросов - ', rr);
  kolvo[form2.vopros.Tag] := rr;
  //writeln('kolvo = ', kolvo[form2.vopros.tag]);
end;

procedure read_5v(nomer2: byte);
begin
  counter := 0;
  {nq:=nomer;}//не уверен, стоит ли убирать
  case nomer2 of
    3:
    begin
      assignfile(base3, 'qbase3.txt');

      reset(base3);
      while not EOF(base3) do
      begin
        readln(base3);
        Inc(counter);
      end;
      counter := counter div (2 + varnumb[nomer2]);

      reset(base3);
      for rr := 1 to counter do
      begin
        readln(base3, q3[rr].question);
        for a := 1 to varnumb[nomer2] do
          readln(base3, q3[rr].variant[a]);
        readln(base3, q3[rr].correct);

      end;

      closefile(base3);
    end;
    4:
    begin
      assignfile(base4, 'qbase4.txt');

      reset(base4);
      while not EOF(base4) do
      begin
        readln(base4);
        Inc(counter);
      end;
      counter := counter div (2 + varnumb[nomer2]);

      reset(base4);
      for rr := 1 to counter do
      begin
        readln(base4, q4[rr].question);
        for a := 1 to varnumb[nomer2] do
          readln(base4, q4[rr].variant[a]);
        readln(base4, q4[rr].correct);

      end;

      closefile(base4);
    end;
  end;
  //writeln('Вопросов - ', rr);
  kolvo[form2.vopros.Tag] := rr;
  //writeln('kolvo = ', kolvo[form2.vopros.tag]);
end;

procedure read5678(nomer3: byte);
begin
  counter := 0;
  {nq:=nomer;}//не уверен, стоит ли убирать
  case nomer3 of
    5:
    begin
      assignfile(base5, 'qbase5.txt');

      reset(base5);
      while not EOF(base5) do
      begin
        readln(base5);
        Inc(counter);
      end;
      counter := counter div (7 + nomer3);

      reset(base5);
      for rr := 1 to counter do
      begin
        readln(base5, q5[rr].question);
        for a := 1 to varnumb[nomer3] do
          readln(base5, q5[rr].variant[a]);
        for a := 1 to 4 do
          readln(base5, q5[rr].correct[a]);
        readln(base5, q5[rr].freebie);
      end;

      closefile(base5);
    end;
    6:
    begin
      assignfile(base6, 'qbase6.txt');

      reset(base6);
      while not EOF(base6) do
      begin
        readln(base6);
        Inc(counter);
      end;
      counter := counter div (7 + nomer3);

      reset(base6);
      for rr := 1 to counter do
      begin
        readln(base6, q6[rr].question);
        for a := 1 to varnumb[nomer3] do
          readln(base6, q6[rr].variant[a]);
        for a := 1 to 4 do
          readln(base6, q6[rr].correct[a]);
        readln(base6, q6[rr].freebie);
      end;

      closefile(base6);
    end;
    7:
    begin
      assignfile(base7, 'qbase7.txt');

      reset(base7);
      while not EOF(base7) do
      begin
        readln(base7);
        Inc(counter);
      end;
      counter := counter div (7 + nomer3);

      reset(base7);
      for rr := 1 to counter do
      begin
        readln(base7, q7[rr].question);
        for a := 1 to varnumb[nomer3] do
          readln(base7, q7[rr].variant[a]);
        for a := 1 to 4 do
          readln(base7, q7[rr].correct[a]);
        readln(base7, q7[rr].freebie);
      end;

      closefile(base7);
    end;
    8:
    begin
      assignfile(base8, 'qbase8.txt');

      reset(base8);
      while not EOF(base8) do
      begin
        readln(base8);
        Inc(counter);
      end;
      counter := counter div (7 + nomer3);

      reset(base8);
      for rr := 1 to counter do
      begin
        readln(base8, q8[rr].question);
        for a := 1 to varnumb[nomer3] do
          readln(base8, q8[rr].variant[a]);
        for a := 1 to 4 do
          readln(base8, q8[rr].correct[a]);
        readln(base8, q8[rr].freebie);
      end;

      closefile(base8);

    end;
  end;
  //writeln('Вопросов - ', rr);
  kolvo[form2.vopros.Tag] := rr;
  //writeln('kolvo = ', kolvo[form2.vopros.tag]);
end;

procedure Pl_sort;
begin
  for a := 1 to 6 do
  begin
    form1.qual[a].blizost := abs(q0[rr].otvet - form1.qual[a].answer);

    form1.qualsort[a] := form1.qual[a];
  end;
  for b := 1 to 5 do
    for _c := 1 to 6 - b do
      if (form1.qualsort[_c].blizost >
        form1.qualsort[_c + 1].blizost) or
        ((form1.qualsort[_c].blizost = form1.qualsort[_c + 1].blizost) and
        (form1.qualsort[_c].time > form1.qualsort[_c + 1].time)) then
      begin
        form1.help[_c] := form1.qualsort[_c];
        form1.qualsort[_c] := form1.qualsort[_c + 1];
        form1.qualsort[_c + 1] := form1.help[_c];
      end;
end;

procedure verno1234;
begin
  respuestas[_14picked].color := $00009FFF;
  current_winnings(form2.vopros.tag);
  ShowMessage('Поздравляю, ответ правильный!');
  form2.accept_1234.Show;
  form2.reject_1234.Show;
  form2.accept_1234.Caption := ('Продолжить игру');
  form2.reject_1234.Caption := ('Забрать деньги');
  form2.groupbox1.hide;
  for a := 1 to varnumb[form2.vopros.Tag] do
    respuestas[a].Hide;
  _14stage := raund;
end;

procedure TForm2.FormShow(Sender: TObject);
begin
  for a := 1 to 5 do
  begin
    va_a_contestar[a] := TButton.Create(form1);
    with va_a_contestar[a] do
    begin
      parent := form2;
      Visible := False;
      left := 170;
      top := 5 + 30 * (a - 1);
      Height := 25;
      Width := 69;
      tag := a;
      Caption := ('Выбор');
    end;

  end;
  termwas := False;
  freebie_avail := True;
  for a := 1 to 9 do
  begin
    respuestas[a] := tpanel.Create(form2);
  end;
  for a := 1 to 2 do
  begin
    buzzer[a] := tpanel.Create(form2);
  end;

  assignfile(baseq, 'otbor.txt');
  assignfile(baset, 'qbaset.txt');
  reset(baseq);
  counter := 0;
  while not EOF(baseq) do
  begin
    readln(baseq);
    counter := counter + 1;
  end;
  counter := trunc(counter / 2);
  reset(baseq);
  for a := 1 to counter do
  begin
    with q0[a] do
    begin
      readln(baseq, question);
      readln(baseq, otvet);
    end;
   // showmessage (inttostr(counter));
  end;
  closefile(baseq);
  showmessage('Внимание, вопрос отборочного тура!');
  randomize;
  rr := random(counter) + 1;
  qotb.Show;
  qotb.Caption := q0[rr].question;
  tim_otbor.Enabled := True;
  for a := 1 to 5 do
  begin
    challenge[a] := TButton.Create(form2);
    challenge[a].tag := a + 10;

  end;

end;

procedure TForm2.reject_1234Click(Sender: TObject);
begin
  accept_1234.hide;
  reject_1234.hide;
  if ((_14stage = default) or (_14stage = kap)) and (vopros.tag<=4) then
  begin
    _14stage := zamen;
    for a := 1 to varnumb[vopros.Tag] do
    begin
      case vopros.tag of
        1: q1[rr2].picked[a] := False;
        2: q2[rr2].picked[a] := False;
        3: q3[rr2].picked[a] := False;
        4: q4[rr2].picked[a] := False;
      end;
      respuestas[a].Color := clnavy;
    end;
    form2.Caption := (form1.qualsort[1].Name + ', выберите ответ');
  end
  else if (_14stage = raund) or ((vopros.tag > 4) and (vopros.tag < 7)) then
  begin
    ShowMessage('Спасибо за игру!');
    halt;
  end;

end;

procedure TForm2.terminator_answerKeyPress(Sender: TObject; var Key: char);
begin
  if (Key = #13) then
  begin
    termstage := after;
    dummy_string := terminator_answer.Text;
    buzzer[1].color := cldefault;
    buzzer[2].Color := cldefault;
    buzzer[1].hide;
    buzzer[2].hide;
    term_text.hide;
    terminator_answer.Text := '';
    terminator_answer.hide;
    if (utf8lowercase(dummy_string) = utf8lowercase(t3rminator[b].otvet)) then
    begin
      ShowMessage('Верно!');
      term_vernoli := True;
      if (z = 1) then
      begin
        winrar := termplayer[1];
        loser := termplayer[2];
      end
      else if (z = 2) then
      begin
        winrar := termplayer[2];
        loser := termplayer[1];
      end;
    end
    else
    begin
      ShowMessage('Неверно! Правильный ответ - ' + t3rminator[b].otvet);
      term_vernoli := False;
      if (z = 1) then
      begin
        winrar := termplayer[2];
        loser := termplayer[1];
      end
      else if (z = 2) then
      begin
        winrar := termplayer[1];
        loser := termplayer[2];
      end;
    end;
    Inc(form1.qualsort[winrar].sgor, form1.qualsort[loser].sgor);
    Inc(form1.qualsort[winrar].share, form1.qualsort[loser].share);
    form1.qualsort[loser].sgor := 0;
    form1.qualsort[loser].share := 0;
    if (loser = 1) then
    begin
      form1.qualsort[6] := form1.qualsort[1];
      form1.qualsort[1] := form1.qualsort[winrar];
      form1.qualsort[winrar] := form1.qualsort[6];
      ShowMessage(form1.qualsort[1].Name + ' - новый капитан команды');
    end;
    termstage := no;
    for b := 1 to 5 do
    begin
      player_osn[b].Caption := form1.qualsort[b].Name;
      money[b].Text := IntToStr(form1.qualsort[b].sgor + form1.qualsort[b].nesgor);
      money[b].show;
      if (form1.qualsort[b].share = 0) then
        money[b].Enabled := False;
    end;
    vopros.Enabled := True;
  end;

end;


procedure TForm2.termTimer(Sender: TObject);
label
  nocancel;
begin
  term.tag := term.tag + 1;
  if (term.tag <= dummy) then
  begin
    repeat
      a := random(5) + 1;
    until form1.qualsort[a].share > 0;
    form2.Caption := form1.qualsort[a].Name;
  end
  else
  begin
    term.Enabled := False;
    term.tag := 0;
    nocancel:
      case questiondlg(form1.qualsort[a].Name, 'будете ли вы играть в терминатор?',
        mtCustom, [mrYes, 'Да', mrNo, 'Нет'], 0) of
        mrCancel: goto nocancel;
        mrYes:
        begin
          Inc(form1.qualsort[a].nesgor, term_pinigai);
          money[a].Caption := IntToStr(form1.qualsort[a].sgor + form1.qualsort[a].nesgor);
          termplayer[1] := a;
          form2.Caption := form1.qualsort[a].Name + ', с кем вы будете играть?';
          for a := 1 to 5 do
          begin
            with challenge[a] do
            begin
              parent := form2;
              Visible := True;
              left := form2.Width - 360;
              top := 5 + 45 * a;
              Height := 35;
              Width := 350;
              Caption := form1.qualsort[a].Name;
              if (form1.qualsort[a].share = 0) or (termplayer[1] = a) then
                hide;
            end;

          end;
        end;
        mrNo:
        begin
          form2.Caption := '';
          termstage := no;
          vopros.Enabled := True;
        end;

      end;

  end;

end;




procedure TForm2.Edit1Enter(Sender: TObject);
begin
  time0 := gettickcount();
end;

procedure TForm2.Edit1KeyPress(Sender: TObject; var Key: char);
begin
  case Key of
    '0'..'9', #8: ;
    else
      Key := #0;
  end;

end;

procedure TForm2.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  halt;
end;

procedure TForm2.FormKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
begin
  if (termstage = otvet_term) then
  begin
    case key of
      65: z := 1;
      76: z := 2;

    end;
    if (key=65) or (key=76) then
    begin

       terminator_answer.Show;
    terminator_answer.SetFocus;
    buzzer[z].color := $007FFF00;
    form2.Caption := form1.qualsort[termplayer[z]].Name +
      ', введите ответ. Для фиксации нажмите Enter';
    //termstage :=pressed_term;
    end;

  end;
end;


procedure TForm2.Edit1Change(Sender: TObject);
begin
  if (length(edit1.Text) < 1) or (length(edit1.Text) > 4) then
  begin
    button1.Enabled := False;
  end
  else
  begin
    button1.Enabled := True;
  end;
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
  with  form1.qual[tim_otbor.Tag] do
  begin
    answer := StrToInt(edit1.Text);
    time := (gettickcount() - time0) / 1000;
    ////writeln(time);
  end;               //здесь дописать
  with form2.edit1 do
  begin
    Enabled := False;
    Text := '';
  end;
  if (tim_otbor.tag < 6) then
    tim_otbor.Enabled := True
  else
  begin
    edit1.hide;
    button1.hide;
    qotb.hide;
    showmessage('Какой же ответ правильный?');
    form2.Caption := 'Правильный ответ - ' + IntToStr(q0[rr].otvet);
    for a := 1 to 5 do
    begin
      player_osn[a] := tlabel.Create(form2);
      with player_osn[a] do
      begin
        parent := form2;
        Visible := True;
        if (a = 1) then
        begin
          Caption := ('Капитан команды');
        end
        else
        begin
          Caption := ('Обычный игрок, ' + IntToStr(a - 1));
        end;
        if (a = 1) then
          color := clmoneygreen;
        top := 5 + 30 * (a - 1);
        Height := 25;
        left := 9;
        Width := 250;
      end;
    end;
    pl_sort;
    showmessage('Кто капитан команды?');
    player_osn[1].Caption := form1.qualsort[1].Name;
    form2.Caption :=
      'Капитан - ' + form1.qualsort[1].Name + ' с ответом ' + IntToStr(form1.qualsort[1].answer);
    for a := 2 to 5 do
    begin
      showmessage ('Кто следующий?');
      player_osn[a].Caption := form1.qualsort[a].Name;
      form2.Caption := 'Игрок номер ' + IntToStr(a - 1) +
        ' - ' + form1.qualsort[a].Name + ' с ответом ' + IntToStr(form1.qualsort[a].answer);
    end;
    showmessage ('Кто выбывает из игры?');
    form2.Caption :=
      'Выбывает игрок ' + form1.qualsort[6].Name + ' с ответом ' + IntToStr(
      form1.qualsort[6].answer);
    showmessage ('Команда готова, мы начинаем игру');
    with form2 do
    begin
      Caption := ('Form2');
      Width := 750;
      Height := 500;
    end;
    for a := 1 to 5 do
    begin
      with form1.qualsort[a] do
      begin
        sgor := 0;
        nesgor := 0;
        share := 1;
      end;
    end;
    with form1.qualsort[6] do
    begin
      sgor := 0;
      nesgor := 0;
      share := 0;
    end;
    combien_de_joueurs;
    for a := 1 to 5 do
    begin
      money[a] := tedit.Create(form2);
      with money[a] do
      begin
        parent := form2;
        Visible := True;
        ReadOnly := True;
        top := 5 + 30 * (a - 1);
        Height := 25;
        left := 9 + player_osn[a].Width + 9;
        Width := 75;
        Text :=
          IntToStr(dough[0] div players);
      end;
    end;
    vopros.Enabled := True;
    vopros.tag := 0; //vopros.tag:=0;
  end;
end;

procedure TForm2.check2Timer(Sender: TObject);
label
  canc, _no_bail8, canc2;
begin
  check2.Enabled := False;
  if (number_of_corr > 0) and (number_of_corr < 3) then
  begin
    yummy := False;
    for winrar := 1 to number_of_corr do
    begin
      randomize;
      case vopros.tag of
        5:
        begin
          repeat
            randprov := random(varnumb[vopros.tag]) + 1;
          until (aceptadas[randprov] = True) and
            ((q5[rr2].correct[1] = randprov) or (q5[rr2].correct[2] = randprov) or
              (q5[rr2].correct[3] = randprov) or (q5[rr2].correct[4] = randprov)) and
            (revealed[randprov] = False);
        end;
        6:
        begin
          repeat
            randprov := random(varnumb[vopros.tag]) + 1;
          until (aceptadas[randprov] = True) and
            ((q6[rr2].correct[1] = randprov) or (q6[rr2].correct[2] = randprov) or
              (q6[rr2].correct[3] = randprov) or (q6[rr2].correct[4] = randprov)) and
            (revealed[randprov] = False);
        end;
        7:
        begin
          repeat
            randprov := random(varnumb[vopros.tag]) + 1;
          until (aceptadas[randprov] = True) and
            ((q7[rr2].correct[1] = randprov) or (q7[rr2].correct[2] = randprov) or
              (q7[rr2].correct[3] = randprov) or (q7[rr2].correct[4] = randprov)) and
            (revealed[randprov] = False);
        end;
        8:
        begin
          repeat
            randprov := random(varnumb[vopros.tag]) + 1;
          until (aceptadas[randprov] = True) and
            ((q8[rr2].correct[1] = randprov) or (q8[rr2].correct[2] = randprov) or
              (q8[rr2].correct[3] = randprov) or (q8[rr2].correct[4] = randprov)) and
            (revealed[randprov] = False);
        end;
      end;
      revealed[randprov] := True;
      ShowMessage('Правильный ли ответ ' + respuestas[randprov].Caption + '?');
      sleep(1500);
      respuestas[randprov].color := $00009FFF;
    end;
    randomize;
    repeat
      randprov := random(varnumb[vopros.tag]) + 1;
    until (aceptadas[randprov] = True) and (revealed[randprov] = False);
    revealed[randprov] := True;
    ShowMessage('Правильный ли ответ ' + respuestas[randprov].Caption + '?');
    sleep(1500);
    respuestas[randprov].color := clred;
    current_winnings(0);
    ShowMessage('Ответ неверный. Покажите нам верные ответы!');
    for b := 1 to varnumb[vopros.tag] do
    begin
      revealed[b] := True;
      case vopros.tag of
        5: with q5[rr2] do
          begin
            if ((correct[1] = b) or (correct[2] = b) or
              (correct[3] = b) or (correct[4] = b)) then
            begin
              respuestas[b].color := $00009FFF;
            end
            else if (aceptadas[b] = True) then
              respuestas[b].color := clred;
          end;
        6: with q6[rr2] do
          begin
            if ((correct[1] = b) or (correct[2] = b) or
              (correct[3] = b) or (correct[4] = b)) then
            begin
              respuestas[b].color := $00009FFF;
            end
            else if (aceptadas[b] = True) then
              respuestas[b].color := clred;
          end;
        7: with q7[rr2] do
          begin
            if ((correct[1] = b) or (correct[2] = b) or
              (correct[3] = b) or (correct[4] = b)) then
            begin
              respuestas[b].color := $00009FFF;
            end
            else if (aceptadas[b] = True) then
              respuestas[b].color := clred;
          end;
        8: with q8[rr2] do
          begin
            if ((correct[1] = b) or (correct[2] = b) or
              (correct[3] = b) or (correct[4] = b)) then
            begin
              respuestas[b].color := $00009FFF;
            end
            else if (aceptadas[b] = True) then
              respuestas[b].color := clred;
          end;
      end;
    end;
    ShowMessage('Игра окончена!');
    halt;

  end
  else if (number_of_corr = 3) or (number_of_corr = 4) then
  begin
    yummy := False;
    for a := 1 to 3 do
    begin
      randomize;
      case vopros.tag of
        5:
        begin
          repeat
            randprov := random(varnumb[vopros.tag]) + 1;
          until (aceptadas[randprov] = True) and
            ((q5[rr2].correct[1] = randprov) or (q5[rr2].correct[2] = randprov) or
              (q5[rr2].correct[3] = randprov) or (q5[rr2].correct[4] = randprov)) and
            (revealed[randprov] = False);
        end;
        6:
        begin
          repeat
            randprov := random(varnumb[vopros.tag]) + 1;
          until (aceptadas[randprov] = True) and
            ((q6[rr2].correct[1] = randprov) or (q6[rr2].correct[2] = randprov) or
              (q6[rr2].correct[3] = randprov) or (q6[rr2].correct[4] = randprov)) and
            (revealed[randprov] = False);
        end;
        7:
        begin
          repeat
            randprov := random(varnumb[vopros.tag]) + 1;
          until (aceptadas[randprov] = True) and
            ((q7[rr2].correct[1] = randprov) or (q7[rr2].correct[2] = randprov) or
              (q7[rr2].correct[3] = randprov) or (q7[rr2].correct[4] = randprov)) and
            (revealed[randprov] = False);
        end;
        8:
        begin
          repeat
            randprov := random(varnumb[vopros.tag]) + 1;
          until (aceptadas[randprov] = True) and
            ((q8[rr2].correct[1] = randprov) or (q8[rr2].correct[2] = randprov) or
              (q8[rr2].correct[3] = randprov) or (q8[rr2].correct[4] = randprov)) and
            (revealed[randprov] = False);
        end;
      end;
      revealed[randprov] := True;
      ShowMessage('Правильный ли ответ ' + respuestas[randprov].Caption + '?');
      sleep(1500);
      respuestas[randprov].color := $00009FFF;
    end;
    b := 0;
    repeat
      Inc(b);
    until (aceptadas[b] = True) and (revealed[b] = False);
    if (vopros.tag = 8) then
      goto _no_bail8;
    if (vopros.tag < 8) then
    begin
      canc:
        case QuestionDlg('Взятка', 'Предлагаю поделить ' + IntToStr(bailout[vopros.tag]) +
          ' и покинуть игру', mtCustom, [mrYes, 'Берём деньги', mrNo,
          'Проверяем четвёртый ответ'], 1) of
          mrCancel: goto canc;
          mrYes:
          begin
            bribe(vopros.tag);
            ShowMessage('Команда забрала деньги. Но был ли правильным ответ ' +
            respuestas[b].Caption + '?');
            revealed[b] := True;
            sleep(1500);
            case vopros.tag of
              5: with q5[rr2] do
                begin
                  if ((correct[1] = b) or (correct[2] = b) or
                  (correct[3] = b) or (correct[4] = b)) then
                  begin
                    respuestas[b].color := $00009FFF;
                    ShowMessage('Вы напрасно остановились!');
                  end
                  else
                  begin
                    respuestas[b].color := clred;
                    ShowMessage('Вы вовремя остановились. Покажите нам верный ответ!');
                    for b := 1 to varnumb[vopros.Tag] do
                    begin
                      revealed[b] := True;
                      if ((correct[1] = b) or (correct[2] = b) or
                      (correct[3] = b) or (correct[4] = b)) then
                      begin
                        respuestas[b].color := $00009FFF;

                      end;
                    end;
                  end;
                end;
              6: with q6[rr2] do
                begin
                  if ((correct[1] = b) or (correct[2] = b) or
                  (correct[3] = b) or (correct[4] = b)) then
                  begin
                    respuestas[b].color := $00009FFF;
                    ShowMessage('Вы напрасно остановились!');
                  end
                  else
                  begin
                    respuestas[b].color := clred;
                    ShowMessage('Вы вовремя остановились. Покажите нам верный ответ!');
                    for b := 1 to varnumb[vopros.tag] do
                    begin
                      revealed[b] := True;
                      if ((correct[1] = b) or (correct[2] = b) or
                      (correct[3] = b) or (correct[4] = b)) then
                      begin
                        respuestas[b].color := $00009FFF;

                      end;
                    end;
                  end;
                end;
              7: with q7[rr2] do
                begin
                  if ((correct[1] = b) or (correct[2] = b) or
                  (correct[3] = b) or (correct[4] = b)) then
                  begin
                    respuestas[b].color := $00009FFF;
                    ShowMessage('Вы напрасно остановились!');
                  end
                  else
                  begin
                    respuestas[b].color := clred;
                    ShowMessage('Вы вовремя остановились. Покажите нам верный ответ!');
                    for b := 1 to varnumb[vopros.tag] do
                    begin
                      revealed[b] := True;
                      if ((correct[1] = b) or (correct[2] = b) or
                      (correct[3] = b) or (correct[4] = b)) then
                      begin
                        respuestas[b].color := $00009FFF;

                      end;
                    end;
                  end;
                end;
            end;

          end;
          mrNo:
          begin
          _no_bail8:
            ShowMessage('Проверяем четвёртый ответ. Верен ли ответ ' +
            respuestas[b].Caption + '?');
            revealed[b] := True;
            sleep(1500);
            case vopros.tag of
              5: with q5[rr2] do
                begin
                  if ((correct[1] = b) or (correct[2] = b) or
                  (correct[3] = b) or (correct[4] = b)) then
                  begin
                    respuestas[b].color := $00009FFF;
                    current_winnings(vopros.tag);
                    ShowMessage('Вы успешно прошли этот раунд');
                      for a := 1 to varnumb[form2.vopros.Tag] do
    respuestas[a].Hide;
                      groupbox1.hide;
                    accept_1234.Show;
                    reject_1234.Show;
                    accept_1234.Caption := ('Продолжить игру');
                    reject_1234.Caption := ('Забрать деньги');
                  end
                  else
                  begin
                    respuestas[b].color := clred;
                    current_winnings(0);
                    ShowMessage('Вы ошиблись! Покажите нам верный ответ!');
                    for b := 1 to varnumb[vopros.tag] do
                    begin
                      revealed[b] := True;
                      if ((correct[1] = b) or (correct[2] = b) or
                      (correct[3] = b) or (correct[4] = b)) then
                      begin
                        respuestas[b].color := $00009FFF;

                      end;
                    end;
                  end;
                end;
              6: with q6[rr2] do
                begin
                  if ((correct[1] = b) or (correct[2] = b) or
                  (correct[3] = b) or (correct[4] = b)) then
                  begin
                    respuestas[b].color := $00009FFF;
                    current_winnings(vopros.tag);
                        ShowMessage('Вы успешно прошли этот раунд');
                        groupbox1.hide;
                          for a := 1 to varnumb[form2.vopros.Tag] do
    respuestas[a].Hide;
                    accept_1234.Show;
                    reject_1234.Show;
                    accept_1234.Caption := ('Продолжить игру');
                    reject_1234.Caption := ('Забрать деньги');

                  end
                  else
                  begin
                    respuestas[b].color := clred;
                    current_winnings(0);
                    ShowMessage('Вы ошиблись! Покажите нам верный ответ!');
                    for b := 1 to varnumb[vopros.tag] do
                    begin
                      revealed[b] := True;
                      if ((correct[1] = b) or (correct[2] = b) or
                      (correct[3] = b) or (correct[4] = b)) then
                      begin
                        respuestas[b].color := $00009FFF;

                      end;
                    end;
                  end;
                end;
              7: with q7[rr2] do
                begin
                  if ((correct[1] = b) or (correct[2] = b) or
                  (correct[3] = b) or (correct[4] = b)) then
                  begin
                    respuestas[b].color := $00009FFF;
                    current_winnings(vopros.tag);
                    ShowMessage('Вы успешно прошли этот раунд');
                      for a := 1 to varnumb[form2.vopros.Tag] do
    respuestas[a].Hide;
                      groupbox1.hide;
                      for a:=1 to 5 do
                      begin
                      if (form1.qualsort[a].share>0) then
                      begin
                           canc2:
                              case QuestionDlg(form1.qualsort[a].name, 'Пойдёте на финальный вопрос или заберёте деньги?', mtCustom, [mrNo, 'Беру деньги', mrYes,
          'Играю дальше'], 1) of
          mrCancel: goto canc2;
          mrYes:    ;
          mrNo:
          begin
          form1.qualsort[a].share:=0;
          money[a].enabled:=false;
          end;
                      end;

                      end;

                  end;
                  combien_de_joueurs;
                  if (players = 0) then begin showmessage('Игра окончена!'); halt; end
                  else if form1.qualsort[1].share=0 then begin
                  a:=0;
                  repeat
                   inc(a);
                  until form1.qualsort[a].share>0;
                  form1.qualsort[6]:=form1.qualsort[a];
                  form1.qualsort[a]:=form1.qualsort[1];
                  form1.qualsort[1]:=form1.qualsort[6];
                  end;
                      for b := 1 to 5 do
    begin
      player_osn[b].Caption := form1.qualsort[b].Name;
      money[b].Text := IntToStr(form1.qualsort[b].sgor + form1.qualsort[b].nesgor);
      if (form1.qualsort[b].share = 0) then
        money[b].Enabled := False;
    end;
    vopros.Enabled := True;
                  end


                  else
                  begin
                    respuestas[b].color := clred;
                    current_winnings(0);
                    ShowMessage('Вы ошиблись! Покажите нам верный ответ!');
                    for b := 1 to varnumb[vopros.tag] do
                    begin
                      revealed[b] := True;
                      if ((correct[1] = b) or (correct[2] = b) or
                      (correct[3] = b) or (correct[4] = b)) then
                      begin
                        respuestas[b].color := $00009FFF;

                      end;
                    end;
                  end;
                end;
              8: with q8[rr2] do
                begin
                  if ((correct[1] = b) or (correct[2] = b) or
                  (correct[3] = b) or (correct[4] = b)) then
                  begin
                    respuestas[b].color := $00009FFF;
                    current_winnings(vopros.tag);
                    ShowMessage('Вы успешно прошли игру!');
                      for a := 1 to varnumb[form2.vopros.Tag] do
    respuestas[a].Hide;
                      groupbox1.hide;
                    accept_1234.Show;
                    reject_1234.Show;
                  end
                  else
                  begin
                    respuestas[b].color := clred;
                    current_winnings(0);
                    ShowMessage('Вы ошиблись! Покажите нам верный ответ!');
                    for b := 1 to varnumb[vopros.tag] do
                    begin
                      revealed[b] := True;
                      if ((correct[1] = b) or (correct[2] = b) or
                      (correct[3] = b) or (correct[4] = b)) then
                      begin
                        respuestas[b].color := $00009FFF;

                      end;

                    end;
                  end;
                end;

            end;


          end;



        end;

     end;


    end

    else if (number_of_corr = 0) then
    begin
      yummy := False;
      repeat
        randprov := random(varnumb[vopros.Tag])
      until (aceptadas[randprov] = True) and
        (revealed[randprov] = False);
      revealed[randprov] := True;
      ShowMessage('Правильный ли ответ ' + respuestas[randprov].Caption + '?');
      sleep(1500);
      respuestas[randprov].color := clred;
      ShowMessage('Ответ неверный. Покажите нам верные ответы! ');
      for b := 1 to varnumb[vopros.tag] do
      begin
        revealed[b] := True;
        case vopros.tag of
          7:
          begin
            with q7[rr2] do
            begin
              revealed[b] := True;
              if ((correct[1] = b) or (correct[2] = b) or (correct[3] = b) or
                (correct[4] = b)) then
              begin
                respuestas[b].color := $00009FFF;

              end
              else if (aceptadas[b] = True) then
              begin
                respuestas[b].color := clred;
              end;

            end;

          end;
          8:
          begin
            with q8[rr2] do
            begin
              revealed[b] := True;
              if ((correct[1] = b) or (correct[2] = b) or (correct[3] = b) or
                (correct[4] = b)) then
              begin
                respuestas[b].color := $00009FFF;

              end
              else if (aceptadas[b] = True) then
              begin
                respuestas[b].color := clred;
              end;

            end;

          end;
        end;

      end;

    end;



end;

procedure TForm2.checkStartTimer(Sender: TObject);
begin

end;

procedure TForm2.checkTimer(Sender: TObject);
begin
  check.Enabled := False;
  case vopros.tag of
    1:
    begin
      ShowMessage(q1[rr2].variant[_14picked] + '. Правильный ли это ответ?');
    end;
    2:
    begin
      ShowMessage(q2[rr2].variant[_14picked] + '. Правильный ли это ответ?');
    end;
    3:
    begin
      ShowMessage(q3[rr2].variant[_14picked] + '. Правильный ли это ответ?');
    end;
    4:
    begin
      ShowMessage(q4[rr2].variant[_14picked] + '. Правильный ли это ответ?');
    end;
  end;
  case vopros.tag of
    1:
    begin
      if (q1[rr2].correct = _14picked) then
      begin
        verno1234;
        //vopros.enabled:=true;//temporary
      end
      else
      begin
        respuestas[_14picked].color := clRed;
        current_winnings(0);
         showmessage('Это неправильный ответ. Какой ответ правильный?');
        respuestas[q1[rr2].correct].color := $00009FFF;

      end;

    end;
    2:
    begin
      if (q2[rr2].correct = _14picked) then
      begin
        verno1234;
      end
      else
      begin
        respuestas[_14picked].color := clRed;
        current_winnings(0);
        showmessage ('Это неправильный ответ. Какой ответ правильный?');
        respuestas[q2[rr2].correct].color := $00009FFF;

      end;

    end;
    3:
    begin
      if (q3[rr2].correct = _14picked) then
      begin
        verno1234;
      end
      else
      begin
        respuestas[_14picked].color := clRed;
        current_winnings(0);
        showmessage       ('Это неправильный ответ. Какой ответ правильный?');
        respuestas[q3[rr2].correct].color := $00009FFF;

      end;

    end;
    4:
    begin
      if (q4[rr2].correct = _14picked) then
      begin
        verno1234;
      end
      else
      begin
        respuestas[_14picked].color := clRed;
        current_winnings(0);
             showmessage ('Это неправильный ответ. Какой ответ правильный?');
        respuestas[q4[rr2].correct].color := $00009FFF;

      end;

    end;
  end;
end;

procedure TForm2.dobavTimer(Sender: TObject);
begin

  dobav.Enabled := False;
  if (krug = True) and (kolvo_otv < 4) then
  begin

    ShowMessage('Кто даст следующий ответ?');
    for a := 1 to 5 do
    begin
      if (form1.qualsort[a].share > 0) then
      begin
        va_a_contestar[a].Visible := True;

      end;

    end;

  end;

end;


procedure TForm2.accept_1234Click(Sender: TObject);
begin
  if ((_14stage = default) or (_14stage = kap)) and (vopros.tag<=4) then
  begin
    _14stage := proverka;
    accept_1234.hide;
    reject_1234.hide;
    form2.Caption := ('Form2');

    check.Enabled := True;
  end
  else if (_14stage = raund) or (vopros.tag >= 4) then
  begin
    ShowMessage('Хорошо, играем дальше');
    if (vopros.tag < 4) or (vopros.tag = 7) then
      vopros.Enabled := True
    else
    begin
      randomize;
      dummy := random(20) + 10;
      ShowMessage('Играем в терминатор!');
      term.Enabled := True;
      accept_1234.Hide;
      reject_1234.hide;
      termstage := rnd;
    end;
  end;

end;

procedure TForm2.tim_otborTimer(Sender: TObject);
begin
  tim_otbor.tag := tim_otbor.tag + 1;
  tim_otbor.Enabled := False;
  if (tim_otbor.tag <= 6) then
  begin
    edit1.Enabled := True;
    form2.Caption := form1.qual[tim_otbor.tag].Name + ', введите ответ';
  end;

end;

procedure TForm2.voprosTimer(Sender: TObject);
label
  _3b, j8;
begin
  vopros.Enabled := False;
  vopros.Tag := vopros.tag + 1;

  _14picked := 0;
  _14stage := default;
  _5to1.tag :=0;

  case vopros.tag of
    1, 2:
    begin
      readq_1234(vopros.tag);

    end;
    3, 4:
    begin
      read_5v(vopros.Tag);
    end;
    5..8:
    begin
      read5678(vopros.tag);
      if (vopros.tag <> 8) then
        activ := 6;

    end;
  end;
  randomize;
  //rr2:=(random(counter))+1;
  //rr2:=9;
  rr2 := random(kolvo[form2.vopros.Tag]) + 1;
  //writeln('Вопрос ', rr2, ' из ', kolvo[form2.vopros.Tag]);
  //writeln('Tag=', vopros.tag, ' rr=', rr);
  accept_1234.hide;
  reject_1234.hide;
  groupbox1.Show;
  with groupbox1 do
  begin
    Caption := IntToStr(dough[vopros.tag]);
    left := 10;
    top := form2.Height - 95;
    Width := form2.Width - 25;
    Height := 85;
  end;
  //writeln('Вопрос №', rr2, ' - ', dough[vopros.tag]);
  case vopros.tag of
    1:
    begin
      label1.Caption := q1[rr2].question;
      //writeln(q1[rr2].question);
    end;
    2:
    begin
      label1.Caption := q2[rr2].question;
      //writeln(q2[rr2].question);
    end;
    3:
    begin
      label1.Caption := q3[rr2].question;
      //writeln(q3[rr2].question);
    end;
    4:
    begin
      label1.Caption := q4[rr2].question;
      //writeln(q4[rr2].question);
    end;
    5:
    begin
      label1.Caption := q5[rr2].question;
      //writeln(q5[rr2].question);
    end;
    6:
    begin
      label1.Caption := q6[rr2].question;
      //writeln(q6[rr2].question);
    end;
    7:
    begin
      label1.Caption := q7[rr2].question;
      //writeln(q7[rr2].question);
    end;
    8:
    begin
      label1.Caption := q8[rr2].question;
      //writeln(q8[rr2].question);
    end;
  end;
  for a := 1 to varnumb[vopros.tag] do
  begin

    with respuestas[a] do
    begin
      parent := form2;
      Visible := True;
      left := form2.Width - 360;
      top := 5 + 45 * (a - 1);
      Height := 35;
      Width := 350;
      tag := a;
      color := clnavy;
      font.Color := clwhite;
      enabled:=true;
    end;
    aceptadas[a]:=false;
    case vopros.tag of
      1:
      begin
        //writeln(q1[rr2].variant[a]);
        respuestas[a].Caption := q1[rr2].variant[a];
      end;



      2:
      begin
        //writeln(q2[rr2].variant[a]);
        respuestas[a].Caption := q2[rr2].variant[a];
      end;
      3:
      begin
        //writeln(q3[rr2].variant[a]);
        respuestas[a].Caption := q3[rr2].variant[a];
      end;
      4:
      begin
        //writeln(q4[rr2].variant[a]);
        respuestas[a].Caption := q4[rr2].variant[a];
      end;
      5:
      begin
        //writeln(q5[rr2].variant[a]);
        respuestas[a].Caption := q5[rr2].variant[a];
        form2.caption:='';
      end;
      6:
      begin
        //writeln(q6[rr2].variant[a]);
        respuestas[a].Caption := q6[rr2].variant[a];
        form2.caption:='';
      end;
      7:
      begin
        //writeln(q7[rr2].variant[a]);
        respuestas[a].Caption := q7[rr2].variant[a];
        form2.caption:='';
      end;
      8:
      begin
        //writeln(q8[rr2].variant[a]);
        respuestas[a].Caption := q8[rr2].variant[a];
        form2.caption:='';
      end;
    end;

  end;
  if (vopros.tag <= 4) then
  begin
    _14stage := otvet;
    form2.Caption := form1.qualsort[6 - vopros.tag].Name + ', выберите ответ';
  end;

  if (vopros.tag >= 5) and (vopros.Tag <= 8) then
  begin
        krug := False;
    kolvo_otv := 0;

    for dummy := 1 to 5 do
      golosoval[dummy] := False;
    for dummy := 1 to 9 do
      revealed[dummy] := False;
    aceptadas[dummy]:=false;
    if(freebie_avail = false) then goto _3b;
    if (freebie_avail = True) then
    begin
      _567 := joker;
      if (vopros.tag=8) then goto j8;
      case QuestionDlg('Джокер', 'Будете использовать джокер?',
          mtCustom, [mrYes, 'Да', mrNo, 'Нет'], 0) of
        mrCancel, mrNo: goto _3b;
        mrYes:
        begin
          j8:ShowMessage('Уберите один неверный ответ');
          case vopros.tag of
            5:
            begin
              respuestas[q5[rr2].freebie].Caption := '';
              respuestas[q5[rr2].freebie].Enabled := False;
            end;

            6:
            begin
              respuestas[q6[rr2].freebie].Caption := '';
              respuestas[q6[rr2].freebie].Enabled := False;
            end;

            7:
            begin
              respuestas[q7[rr2].freebie].Caption := '';
              respuestas[q7[rr2].freebie].Enabled := False;
            end;
                        8:
            begin
              respuestas[q8[rr2].freebie].Caption := '';
              respuestas[q8[rr2].freebie].Enabled := False;
            end;
          end;

          freebied := True;
          freebie_avail := False;
          goto _3b;
        end;
      end;
    end
    else
    begin
      _3b:
        _567 := priem;

    end;
    _5to1.Enabled := True;
  end;

end;

procedure TForm2._5to1Timer(Sender: TObject);
begin
  if (vopros.tag<8) then
  begin
   if (activ > 1) and (krug = False) then
   begin
     repeat
       Dec(activ);
       _5to1.tag := _5to1.tag + 1;
     until (form1.qualsort[activ].share > 0) or (_5to1.Tag >= 5);
     if (golosoval[1] = True) or (kolvo_otv >= 4) then
     begin
       krug := True;
     end;
   end;
   if (_5to1.Tag <= 5) and (golosoval[1] = False) and (krug = False) then
   begin
     _5to1.Enabled := False;
     ShowMessage(form1.qualsort[activ].Name + ', отвечайте');
   end
   else
   begin
     with _5to1 do
     begin
       Enabled := False;
       tag := 5;
     end;

   end;
   if (golosoval[1] = True) and (kolvo_otv < 4) then
   begin
     krug := True;
     dobav.Enabled := True;
   end;
  end
  else begin
    activ:=1;
         _5to1.Enabled := False;
     ShowMessage(form1.qualsort[activ].Name + ', отвечайте');
  end;
end;

procedure tpanel.click;
begin
  inherited;
  case form2.vopros.tag of
    1..4:
    begin
      case _14stage of
        otvet:
        begin
          case form2.vopros.tag of
            1: q1[rr2].picked[tag] := True;
            2: q2[rr2].picked[tag] := True;
            3: q3[rr2].picked[tag] := True;
            4: q4[rr2].picked[tag] := True;
          end;

          color := $00FFFF00;
          _14stage := kap;
          _14picked := tag;
          form2.Caption := (form1.qualsort[1].Name + ', вы согласны с этим ответом?');
          form2.accept_1234.Show;
          form2.reject_1234.Show;
          form2.accept_1234.Caption := ('Согласен');
          form2.reject_1234.Caption := ('Не согласен');
        end;
        zamen:
        begin
          case form2.vopros.tag of
            1: q1[rr2].picked[tag] := True;
            2: q2[rr2].picked[tag] := True;
            3: q3[rr2].picked[tag] := True;
            4: q4[rr2].picked[tag] := True;
          end;
          _14picked := tag;
          color := $00FFFF00;
          _14stage := proverka;
          form2.check.Enabled := True;
        end;

      end;
    end;
    5..7:
    begin
      if (((form2._5to1.Enabled = False) and (kolvo_otv < 4)) and
        (golosoval[activ] = False) and (aceptadas[tag] = False)) and (_567 = priem) then
      begin
        //writeln('Достаю до ввода 5678');
        aceptadas[tag] := True;
        color := $00FFFF00;
        Inc(kolvo_otv);
        //writeln (kolvo_otv, ' ответ(ов)');
        golosoval[activ] := True;
        form2._5to1.Enabled := True;
      end
      else if (((form2.dobav.Enabled = False) and (kolvo_otv < 4)) and
        (golosoval[activ] = False) and (aceptadas[tag] = False)) and (_567 = priem) then
      begin
        aceptadas[tag] := True;
        color := $00FFFF00;
        Inc(kolvo_otv);
         //writeln (kolvo_otv, ' ответ(ов)');
        golosoval[activ] := True;
        form2.dobav.Enabled := True;
      end;
      if (kolvo_otv = 4) and (_567 = priem) then
      begin
        case QuestionDlg('Меняем?', 'Можете поменять один ответ',
            mtCustom, [mrYes, 'Да', mrNo, 'Нет'], 0) of
          mrCancel, mrNo:
          begin
            _567 := _proverka;
            viele_richtig;
            //writeln('Без замены верных ответов: ', number_of_corr);
           // //writeln('Верные ответы: ', q5[rr2].correct[1],
           //   q5[rr2].correct[2], q5[rr2].correct[3], q5[rr2].correct[4]);
          end;
          mrYes:
          begin
            _567 := zamena1;

          end;
        end;
      end
      else if (_567 = zamena1) and (aceptadas[tag] = True) then
      begin
        Dec(kolvo_otv);
        aceptadas[tag] := False;
        color := clnavy;
        ShowMessage('Поставьте свой ответ');
        _567 := zamena2;
      end
      else if (_567 = zamena2) and (aceptadas[tag] = False) then
      begin
        Inc(kolvo_otv);
        aceptadas[tag] := True;
        color := $00FFFF00;
        _567 := _proverka;
        viele_richtig;
        //writeln('С заменой верных ответов: ', number_of_corr);
       // //writeln('Верные ответы: ', q5[rr2].correct[1], q5[rr2].correct[2],
        //  q5[rr2].correct[3], q5[rr2].correct[4]);
      end;

    end;
    8: begin
       if (form2._5to1.Enabled = False) and (kolvo_otv < 4) then
          begin
         aceptadas[tag] := True;
        color := $00FFFF00;
        Inc(kolvo_otv);
         //writeln (kolvo_otv, ' ответ(ов)');
        golosoval[activ] := True;
        form2.dobav.Enabled := True;
          end;
       if (kolvo_otv = 4) then viele_richtig;
       end;

  end;

end;

procedure TButton.click;
begin
  inherited;
  if (tag >= 11) and (tag <= 15) then
  begin
    if (termwas = False) then
    begin

      reset(baset);
      counter := 0;
      while not EOF(baset) do
      begin
        readln(baset);
        Inc(counter);
      end;
      reset(baset);
      counter := counter div 2;
      for rr := 1 to counter do
      begin
        with t3rminator[rr] do
        begin

          readln(baset, tekst);
          readln(baset, otvet);
          if (form2.vopros.tag = 4) then
            has_been := False;

        end;
      end;
      closefile(baset);
      termwas := True;
    end;
    randomize;
    termplayer[2] := tag - 10;
    //writeln('Voprosov v terminatore: ', rr);
    repeat
      b := random(rr) + 1;
    until t3rminator[b].has_been = False;
    t3rminator[b].has_been := True;
    //writeln('vopros #', b);
    //writeln(t3rminator[b].tekst);
    //writeln(t3rminator[b].otvet);
    for a := 1 to 5 do
    begin
      challenge[a].hide;
    end;
    form2.term_text.Show;
    form2.term_text.Caption := t3rminator[b].tekst;
    for a := 1 to 2 do
    begin
      with buzzer[a] do
      begin
        parent := form2;
        Visible := True;
        top := 250;
        left := a * 180;
        Width := 100;
        Height := 45;
      end;
    end;
    buzzer[1].Caption := form1.qualsort[termplayer[1]].Name + ' (A)';
    buzzer[2].Caption := form1.qualsort[termplayer[2]].Name + ' (L)';
    for a:=1 to 5 do money[a].visible:=false;
    form2.setfocus;
    termstage := otvet_term;
  end
  else if (tag>=1) and (tag<=5) then
  begin
     for a:=1 to 5 do
  begin
  va_a_contestar[a].Hide;
  end;
activ:=tag;
golosoval[activ]:=false;
showmessage(form1.qualsort[activ].name+', отвечайте');
  end;
end;
end.
